# geth-attacker
This project consists of three parts.

- 'geth-attacker-incoming' performs the attack on the 17 connection slots for
  incoming connections. It is a slightly manipulated geth that is configured to
  discard all incoming connections and only establish connections to the boot
  node (i.e., the victim node) configured in 'scripts/geth-attacker-incoming.sh'. 
  Also, it doesn't start the udp discovery service. The 'geth-attacker-incoming' 
  nodes for our attack can be started by running 'scripts/geth-attacker-incoming.sh'.
- 'geth-attacker-outgoing' is a slightly manipulated geth that is configured to
  only allow incoming connections from the victim node. It does not establish
  any outgoing connections and doesn't start the udp discovery service.
  'geth-attacker-outgoing' nodes are run and managed by 'geth-test'.
- 'geth-test' is a partial re-implementation of the geth udp discovery protocol.
  'geth-test' performs the attack on the eight outgoing (table and lookupBuffer) 
  connection slots. It manages the 'geth-attacker-outgoing' nodes.

## start attack
We assume that this folder is located directly in the user's home directory (~).

1. Build the project by running 'make'.
2. Run '~/ethAttack/scripts/geth-attacker-incoming.py start' to start the attack 
   on the incoming connection slots.
3. Run '~/ethAttack/scripts/geth-attacker-outgoing.py start' to start the
   attack on the outgoing connetion slots.

## stop attack

1. Run '~/ethAttack/scripts/geth-attacker-incoming.py stop' and 
   '~/ethAttack/scripts/geth-attacker-outgoing.py stop' on the respective 
   attacker machines.
