#!/usr/bin/env python3
# -*- coding: utf8 -*-

import argparse
import os
from pathlib import Path

homedir = str(Path.home())
lockfile = homedir + "/ethAttack/.udp_attack.lock"

def start():
    print("Starting UDP attacker...")
    if os.path.isfile(lockfile):
        print("failure: attack is already running. Run",
                "'geth-attacker-outgoing.py stop' to kill it.")
    else:
        f = open(lockfile,'w')
        f.close()
        os.system("tmux new-session -d -s my_session '"
                +homedir+"/ethAttack/geth-test/bin/main'")

def stop():
    print("Stopping UDP attacker...")
    os.system("tmux kill-server")
    os.system("killall -9 geth") # just in case any geths survived...
    if os.path.isfile(lockfile):
        os.remove(lockfile)

def status():
    if os.path.isfile(lockfile):
        print("attack is running")
    else:
        print("attack is NOT running")

def usage():
    print("usage: geth-attacker-outgoing.py {start,stop,status}")

parser = argparse.ArgumentParser(prog='geth-attacker-outgoing.py')
sp = parser.add_subparsers()
sp_start = sp.add_parser('start', help='starts attacker')
sp_stop = sp.add_parser('stop', help='stops attacker')
sp_status = sp.add_parser('status', help='shows attack status')

sp_stop.set_defaults(func=stop)
sp_start.set_defaults(func=start)
sp_status.set_defaults(func=status)

args = parser.parse_args()
try: args.func()
except: usage()
